﻿Import-Module "$PSScriptRoot\NtApi"
$pinfo = $null
$procs = $null

try
{
    $config = New-Object NtApi.CreateUserProcess
    $config.CommandLine = "demo"
    $config.ThreadFlags = "Suspended"

    $explorer = $null
    $procs = [NtApi.NtSystemCalls]::GetProcesses("CreateProcess, QueryLimitedInformation")
    foreach($proc in $procs)
    {
        try
        {
            $path = [NtApi.NtSystemCalls]::GetProcessImageName($proc, $false)
            if ($path.EndsWith("explorer.exe", "CurrentCultureIgnoreCase"))
            {
                $explorer = $proc
                break
            }
        }
        catch {}
    }

    if ($explorer -ne $null)
    {
        $config.AdditionalAttributes.Add([NtApi.ProcessAttribute]::ParentProcess($explorer))
        $pinfo = $config.Start("\??\" + $PSScriptRoot + "\bin\demo.exe")
    
        Write-Host "Created Process:", $pinfo.GetProcessImageName($false)
        $pinfo.Resume() | Out-Null
    }
    else
    {
        Write-Host "Couldn't find explorer process"
    }
}
catch
{
    Write-Host $_.Exception.Message
}
finally
{
    if ($procs -ne $null)
    {
        foreach($proc in $procs)
        {
            $proc.Close()
        }
    }

    if ($pinfo -ne $null)
    {
        $pinfo.Dispose();
    }
}